class AffineRegistration(Model) :
    "Find the optimal affine deformation."
    def __init__(self, α) :
        "Defines the parameters of an affine deformation of α."
        super(Model, self).__init__()
        self.α_i = α[0].clone()
        self.x_i = α[1].clone()
        self.A = Parameter(torch.eye(2)   ) # Transformation
        self.B = Parameter(torch.zeros(2) ) # Translation

    def __call__(self, t=1.) :
        x_t = self.x_i @ ((1-t)*torch.eye(2)+t*self.A) + t*self.B
        return self.α_i, x_t 
    
    def cost(self, target) :
        "Returns a cost to optimize."
        return fidelity( self(), target)

affine = train_and_display(AffineRegistration, α, β)
